## File: 109project.R
## Author: John Rothfels (rothfels)
## Description: Naive Bayes Classifier + Logistic Regression
## ---------------------------------------------------------

## This file completes the 109 final project with very little code.
## It could be made even shorter. You'll notice that much of the
## code (at the bottom) is copy-pasted for an interactive session and
## could easily be decomposed. The vast majority of the code necessary to
## complete the assignment is in reading the files and formatting them
## into data frames. Notice that both classifiers are run over data
## almost identically. This is a common theme in R.


FileToDataFrameNaive <- function(file) {
  ## Reads a CS109 final project file into a data frame.

  x <- scan(file, what = " ", n = -1, sep = "\n")
  x.split <- strsplit(x, c(":? "))
  x.split <- lapply(x.split, as.numeric)

  n.var <- x.split[[1]]
  n.observations <- x.split[[2]]

  x.split <- x.split[-1:-2]

  vars <- lapply(x.split, function(i) factor(i[-length(i)]))
  responses <- sapply(x.split, function(i) i[length(i)])

  vars <- data.frame(vars)
  vars <- t(vars) ## transpose

  rownames(vars) <- NULL
  colnames(vars) <- paste("X", 1:n.var, sep = "")

  data <- data.frame(vars, response = responses)
  return(data)
}

FileToDataFrame <- function(file) {
  ## This is an abridged version of the function above. Generally, we should
  ## be able to call 'read.table' on whatever file we want to read into a
  ## dataframe. R users will usually keep data in suitable format to read into
  ## R. The 109 datasets, however, are not structured appropriately and involve
  ## a small amount of restructuring. Namely, we need to get rid of the ":"
  ## character. This can be done in many ways, but we demonstrate one here.
  ## Notice that the naming of the columns of the data frame generated is done
  ## automatically

  data <- readLines(file, warn = FALSE)
  data <- gsub(":", "", data)
  data <- data[-1:-2]
  tc <- textConnection(data) # File IO
  df <- read.table(tc, sep = " ", colClasses = "factor")
  close(tc)
  return(df)
}

## This package contains the naive bayes classifier.
library(e1071)

setwd('/Users/kevinshin92/Dropbox/Current-Documents/CS109L/lectures/Week9/L11/')

## Simple Data Set:

train <- FileToDataFrame("simple-train.txt")
test <- FileToDataFrame("simple-test.txt")

m <- glm(response ~ ., family = binomial("logit"), data = train)
prediction <- predict(m, test, type = "response")
prediction <- prediction > .5
mean(prediction == test$response)

m2 <- naiveBayes(response ~ ., data = train)
prediction <- predict(m2, test, type = "raw")
prediction <- prediction[, 2] > prediction[, 1]
mean(prediction == test$response)


## Vote Data Set:

train <- FileToDataFrame("vote-train.txt")
test <- FileToDataFrame("vote-test.txt")

m <- glm(response ~ ., family = binomial("logit"), data = train)
prediction <- predict(m, test, type = "response")
prediction <- prediction > .5
mean(prediction == test$response)

m2 <- naiveBayes(response ~ ., data = train)
prediction <- predict(m2, test, type = "raw")
prediction <- prediction[, 2] > prediction[, 1]
mean(prediction == test$response)


## Heart Data Set:

train <- FileToDataFrame("heart-train.txt")
test <- FileToDataFrame("heart-test.txt")

m <- glm(response ~ ., family = binomial("logit"), data = train)
prediction <- predict(m, test, type = "response")
prediction <- prediction > .5
mean(prediction == test$response)

m2 <- naiveBayes(response ~ ., data = train)
prediction <- predict(m2, test, type = "raw")
prediction <- prediction[, 2] > prediction[, 1]
mean(prediction == test$response)
